## ghc 7.10.3

=== Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

ifeq "$(wildcard distrib/)" ""

# We're in a bindist

.PHONY: default
default:
	@echo 'Run "make install" to install'
	@false

.PHONY: install show
install show:
	$(MAKE) -r --no-print-directory -f ghc.mk $@ BINDIST=YES NO_INCLUDE_DEPS=YES

else

default : all
	@:

# For help, type 'make help'
.PHONY: help
help:
	@cat MAKEHELP.md

ifneq "$(filter maintainer-clean distclean clean help,$(MAKECMDGOALS))" ""
-include mk/config.mk
else
include mk/config.mk
ifeq "$(ProjectVersion)" ""
$(error Please run ./configure first)
endif
endif

include mk/custom-settings.mk

# Verify that stage 0 LLVM backend isn't affected by Bug #9439 if needed
ifeq "$(GHC_LLVM_AFFECTED_BY_9439)" "1"
ifneq "$(findstring -fllvm,$(GhcHcOpts) $(GhcStage1HcOpts))" ""
$(error Stage 0 compiler is affected by Bug #9439. Refusing to bootstrap with -fllvm)
endif
endif

# No need to update makefiles for these targets:
REALGOALS=$(filter-out binary-dist binary-dist-prep bootstrapping-files framework-pkg clean clean_% distclean maintainer-clean show echo help test fulltest,$(MAKECMDGOALS))

# configure touches certain files even if they haven't changed.  This
# can mean a lot of unnecessary recompilation after a re-configure, so
# here we cache the old versions of these files so we can restore the
# timestamps.
%.old:  %
	@set -x && test -f $@ && cmp -s $< $@ || cp -p $< $@
	touch -r $@ $<


# NB. not the same as saying '%: ...', which doesn't do the right thing:
# it does nothing if we specify a target that already exists.
.PHONY: $(REALGOALS)
$(REALGOALS) all: mk/config.mk.old mk/project.mk.old compiler/ghc.cabal.old
ifneq "$(OMIT_PHASE_0)" "YES"
	@echo "===--- building phase 0"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=0 phase_0_builds
endif
ifneq "$(OMIT_PHASE_1)" "YES"
	@echo "===--- building phase 1"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=1 phase_1_builds
endif
	@echo "===--- building final phase"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=final $@

binary-dist: binary-dist-prep
	mv bindistprep/*.tar.$(TAR_COMP_EXT) .

binary-dist-prep:
ifeq "$(mingw32_TARGET_OS)" "1"
	$(MAKE) -r --no-print-directory -f ghc.mk windows-binary-dist-prep
else
	rm -f bindist-list
	$(MAKE) -r --no-print-directory -f ghc.mk bindist BINDIST=YES
	$(MAKE) -r --no-print-directory -f ghc.mk unix-binary-dist-prep
endif

clean distclean maintainer-clean:
	$(MAKE) -r --no-print-directory -f ghc.mk $@ CLEANING=YES
	test ! -d testsuite || $(MAKE) -C testsuite $@

$(filter clean_%, $(MAKECMDGOALS)) : clean_% :
	$(MAKE) -r --no-print-directory -f ghc.mk $@ CLEANING=YES

bootstrapping-files show echo:
	$(MAKE) -r --no-print-directory -f ghc.mk $@

ifeq "$(darwin_TARGET_OS)" "1"
framework-pkg:
	$(MAKE) -C distrib/MacOS $@
endif

# If the user says 'make A B', then we don't want to invoke two
# instances of the rule above in parallel:
.NOTPARALLEL:

endif

.PHONY: test
test:
	$(MAKE) -C testsuite/tests CLEANUP=1 OUTPUT_SUMMARY=../../testsuite_summary.txt fast

.PHONY: fulltest
fulltest:
	$(MAKE) -C testsuite/tests CLEANUP=1 OUTPUT_SUMMARY=../../testsuite_summary.txt

=== distrib/Makefile ===

include Makefile-vars

.PHONY: install-strip install postinstall denounce show-install-setup

#.PHONY: in-place
# This has bitrotted:
#in-place ::
#	@if test -x "./post-inplace-script" ; then \
#		echo "Running project-specific post-inplace script ..." ; \
#		./post-inplace-script $(platform) `pwd` \
#			$(package)-$(version); \
#		echo "Done" ; \
#	fi
#	@echo "Finished configuring..to use, add `pwd`/bin/$(platform) to your PATH."

install-strip:
	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' install

install ::
	$(INSTALL_DIR) $(bindir)
	$(INSTALL_DIR) $(datadir)
	echo "[]" > $(datadir)/package.conf

install::
	$(MAKE) -C includes  install      DOING_BIN_DIST=YES
	$(MAKE) -C utils     install      DOING_BIN_DIST=YES
	$(MAKE) -C rts       install      DOING_BIN_DIST=YES
	$(MAKE) -C libraries install      DOING_BIN_DIST=YES
	$(MAKE) -C libffi    install      DOING_BIN_DIST=YES
	$(MAKE) -C compiler  install      DOING_BIN_DIST=YES
	$(MAKE) -C ghc       install      DOING_BIN_DIST=YES
	$(MAKE) -C driver    install      DOING_BIN_DIST=YES
	$(MAKE) -C gmp       install      DOING_BIN_DIST=YES
	$(MAKE) -C docs      install-docs DOING_BIN_DIST=YES
	$(MAKE) -C libraries/Cabal/doc install-docs DOING_BIN_DIST=YES
	$(INSTALL_DATA) $(INSTALL_OPTS) settings $(libdir)

install :: postinstall denounce

# Look to see if $(bindir) is in $(PATH). Assumes there are no funky
# characters.
GREPPED_PATH=$(shell echo ":$(PATH):" | grep ":$(bindir):")

denounce:
	@echo
	@echo =======================================================================
	@echo Installation of $(package)-$(version) was successful.
	@echo
ifeq "$(GREPPED_PATH)" ""
	@echo To use, add $(bindir) to your PATH.
	@echo
endif
	@if test -f $(htmldir)/index.html; then \
	   echo For documentation, see $(htmldir)/index.html ; \
	else \
	   echo "Warning: this binary distribution does NOT contain documentation!" ; \
	fi
	@echo =======================================================================

postinstall:
	@if test -x "./post-install-script" ; then \
		echo "Running project-specific post-install script ..." ; \
		./post-install-script $(platform) $(libdir) ; \
		echo "Done" ; \
	fi

show-install-setup:
	@echo "Install setup..."
	@echo "bindir  = $(bindir)"
	@echo "libdir  = $(libdir) (libdir  = $(libdir))"
	@echo "datadir = $(datadir) (datadir = $(datadir))"

=== libraries/Makefile ===
dir = libraries
TOP = ..
SPEC_TARGETS = 1
include $(TOP)/mk/sub-makefile.mk

.PHONY: 1
1 :
	+$(TOPMAKE) stage1_libs

.PHONY: extra-help
help : extra-help
extra-help :
	@echo "  make 1"
	@echo
	@echo "     Build all libraries that are built by the stage1 GHC"
	@echo

=== docs/backpack/Makefile ===
all: backpack-impl.pdf backpack-manual.pdf

backpack-impl.pdf: backpack-impl.tex
	latexmk -pdf -latexoption=-halt-on-error -latexoption=-file-line-error -latexoption=-synctex=1 backpack-impl.tex && touch paper.dvi || ! rm -f $@

backpack-manual.pdf: backpack-manual.tex
	latexmk -pdf -latexoption=-halt-on-error -latexoption=-file-line-error -latexoption=-synctex=1 backpack-manual.tex && touch paper.dvi || ! rm -f $@

=== docs/core-spec/Makefile ===
OTT_FILES = CoreSyn.ott CoreLint.ott OpSem.ott
OTT_TEX   = CoreOtt.tex
OTT_OPTS  = -tex_show_meta false
TARGET    = core-spec

$(TARGET).pdf: $(TARGET).tex $(OTT_TEX)
	latex -output-format=pdf $<
	latex -output-format=pdf $<

$(TARGET).tex: $(TARGET).mng $(OTT_FILES)
	ott $(OTT_OPTS) -tex_filter $< $@ $(OTT_FILES)

$(OTT_TEX): $(OTT_FILES)
	ott -tex_wrap false $(OTT_OPTS) -o $@ $^

.PHONY: clean
clean:
	rm -f $(TARGET).pdf $(TARGET).tex $(OTT_TEX) *.aux *.fdb_latexmk *.log

=== libraries/time/Makefile ===
default: clean test install sdist

# Building

clean:
	cabal clean

configure:
	cabal configure --enable-library-profiling --enable-executable-profiling --enable-tests

build: configure
	cabal build --ghc-options=-Werror

test: configure
	cabal test --ghc-options=-Werror --test-option=--hide-successes --test-option=--color

haddock: configure
	cabal haddock

copy: build test haddock
	cabal copy

install:
	cabal install --user --ghc-options=-Werror --enable-library-profiling --enable-executable-profiling

sdist: clean configure
	cabal sdist

# switch off intermediate file deletion
.SECONDARY:

.PHONY: default clean configure build haddock copy install test sdist

=== utils/checkUniques/Makefile ===

GHC = ghc

PREL_NAMES = ../../compiler/prelude/PrelNames.lhs
DS_META = ../../compiler/deSugar/DsMeta.hs

.PHONY: check

check: checkUniques
	./checkUniques mkPreludeClassUnique   $(PREL_NAMES)
	./checkUniques mkPreludeTyConUnique   $(PREL_NAMES) $(DS_META)
	./checkUniques mkPreludeDataConUnique $(PREL_NAMES)
	./checkUniques mkPreludeMiscIdUnique  $(PREL_NAMES) $(DS_META)

checkUniques: checkUniques.hs
	$(GHC) -O -XHaskell2010 --make $@

=== utils/deriveConstants/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009-1012 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/deriveConstants
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== utils/genargs/Makefile ===
comma = ,
BAR= "-L\"foo bar\""
FOO= $(patsubst %,$(comma)"%",$(BAR))

test:
	@echo "$(FOO)"
	@echo "$(BAR)" | $(PERL) genargs.pl -comma
	@echo

=== utils/mkUserGuidePart/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/mkUserGuidePart
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== libraries/Cabal/Cabal/Makefile ===

VERSION=1.22.5.0

#KIND=devel
KIND=rc
#KIND=cabal-latest

PREFIX=/usr/local
HC=ghc
GHCFLAGS=-Wall -threaded
SSH_USER=$(USER)

all: build

# build the library itself

SOURCES=Distribution/*.hs Distribution/Simple/*.hs Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs Distribution/Simple/Build/*.hs Distribution/Compat/*.hs Distribution/Simple/Program/*.hs
CONFIG_STAMP=dist/setup-config
BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
HADDOCK_STAMP=dist/doc/html/Cabal/index.html
USERGUIDE_STAMP=dist/doc/users-guide/index.html
SDIST_STAMP=dist/Cabal-$(VERSION).tar.gz
DISTLOC=dist/release
DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz

TMP := $(shell mktemp -d)

COMMA=,

setup: $(SOURCES) Setup.hs
	-mkdir -p dist/setup
	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs -o setup

$(CONFIG_STAMP): setup Cabal.cabal
	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)

build: $(BUILD_STAMP)
$(BUILD_STAMP): $(CONFIG_STAMP) $(SOURCES)
	./setup build

install: $(BUILD_STAMP)
	./setup install

# documentation...

haddock: $(HADDOCK_STAMP)
$(HADDOCK_STAMP) : $(CONFIG_STAMP) $(BUILD_STAMP)
	./setup haddock

PANDOC=pandoc
PANDOC_OPTIONS= \
	--standalone \
	--smart \
	--css=$(PANDOC_HTML_CSS)
PANDOC_HTML_OUTDIR=dist/doc/users-guide
PANDOC_HTML_CSS=Cabal.css

users-guide: $(USERGUIDE_STAMP) doc/*.markdown
$(USERGUIDE_STAMP): doc/*.markdown
	mkdir -p $(PANDOC_HTML_OUTDIR)
	for file in $^; do \
		[ $${file} != doc/index.markdown ] && TOC=--table-of-contents || TOC=; \
		$(PANDOC) $(PANDOC_OPTIONS) $${TOC} --from=markdown --to=html --output $(PANDOC_HTML_OUTDIR)/$$(basename $${file} .markdown).html $${file}; \
	done
	cp doc/$(PANDOC_HTML_CSS) $(PANDOC_HTML_OUTDIR)

docs: haddock users-guide

clean:
	rm -rf dist/
	rm -f setup

# testing...

moduleTest: tests/ModuleTest.hs tests/PackageDescriptionTests.hs
	mkdir -p dist/test
	$(HC) --make -Wall -DDEBUG -odir dist/test -hidir dist/test \
		-itests tests/ModuleTest.hs -o moduleTest

#tests: moduleTest clean
#	cd tests/A && $(MAKE) clean
#	cd tests/HUnit-1.0 && $(MAKE) clean
#	cd tests/A && $(MAKE)
#	cd tests/HUnit-1.0 && $(MAKE)

#check:
#	rm -f moduleTest
#	$(MAKE) moduleTest
#	./moduleTest

# distribution...

$(SDIST_STAMP) : $(BUILD_STAMP)
	./setup sdist

dist: $(DIST_STAMP)
$(DIST_STAMP) : $(HADDOCK_STAMP) $(USERGUIDE_STAMP) $(SDIST_STAMP)
	rm -rf $(DISTLOC)
	mkdir $(DISTLOC)
	tar -xzf $(SDIST_STAMP) -C $(DISTLOC)/
	mkdir -p $(DISTLOC)/Cabal-$(VERSION)/doc
	cp -r dist/doc/html $(DISTLOC)/Cabal-$(VERSION)/doc/API
	cp -r dist/doc/users-guide $(DISTLOC)/Cabal-$(VERSION)/doc/
	cp changelog $(DISTLOC)/Cabal-$(VERSION)/
	tar -C $(DISTLOC) -czf $(DISTLOC)/Cabal-$(VERSION).tar.gz Cabal-$(VERSION)
	mv $(DISTLOC)/Cabal-$(VERSION)/doc $(DISTLOC)/
	mv $(DISTLOC)/Cabal-$(VERSION)/changelog $(DISTLOC)/
	rm -r $(DISTLOC)/Cabal-$(VERSION)/
	@echo "Cabal tarball built: $(DIST_STAMP)"
	@echo "Release fileset prepared: $(DISTLOC)/"

release: $(DIST_STAMP)
	scp -r $(DISTLOC) $(SSH_USER)@haskell.org:/home/web/haskell.org/cabal/release/cabal-$(VERSION)
	ssh $(SSH_USER)@haskell.org 'cd /home/web/haskell.org/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'

release-new: $(DIST_STAMP)
	@echo "cd cabal/release" > $(TMP)/cabal-sftp-$(VERSION)
	@echo "-mkdir cabal-$(VERSION)" >> $(TMP)/cabal-sftp-$(VERSION)
	@echo "cd cabal-$(VERSION)" >> $(TMP)/cabal-sftp-$(VERSION)
	@echo "lcd $(DISTLOC)" >> $(TMP)/cabal-sftp-$(VERSION)
	@echo "put -r . ." >> $(TMP)/cabal-sftp-$(VERSION)
	sftp -b $(TMP)/cabal-sftp-$(VERSION) $(SSH_USER)@wiki.haskell.org
	@echo "You still need to manually update the 'latest' links"

# tags...

TAGSSRCDIRS = Distribution Language
tags TAGS: $(SOURCES)
	find $(TAGSSRCDIRS) -name \*.\*hs | xargs hasktags

=== libraries/containers/benchmarks/Makefile ===
all:

bench-%: %.hs force
	ghc -O2 -DTESTING $< -i../$(TOP) -o $@ -outputdir tmp -rtsopts

bench-%.csv: bench-%
	./bench-$* $(BENCHMARK) -v -u bench-$*.csv

.PHONY: force clean veryclean
force:

clean:
	rm -rf tmp $(patsubst %.hs, bench-%, $(wildcard *.hs))

veryclean: clean
	rm -rf *.csv

=== debian/changelog ===
ghc (7.10.3-7) unstable; urgency=medium

  [ Joachim Breitner ]
  * Tighten build-depends on llvm-3.5, to pull in backported version
  * Tighten build-depends on ghc; this does not build against 7.6 any more, so
    let's use the 7.8 already in backports.

  [ Colin Watson ]
  * Run /usr/lib/ghc-doc/gen_contents_index from ghc-doc.postinst with HOME
    set to a temporary directory, so that it doesn't pick up stray user
    configuration and so that it works reliably in autopkgtests.

 -- Colin Watson <cjwatson@debian.org>  Fri, 29 Jan 2016 15:58:13 +0000

ghc (7.10.3-6) unstable; urgency=medium

  * Let GHC break cabal-install (<< 1.22), due to
    "ghc no longer supports single-file style package databases"

 -- Joachim Breitner <nomeata@debian.org>  Tue, 12 Jan 2016 10:37:19 +0100

ghc (7.10.3-5) unstable; urgency=medium

  * ghc-doc Breaks/Replaces libghc-terminfo-doc (<< 0.3.2.5-4),
    libghc-transformers-doc (<< 0.3.0.0-6), libghc-xhtml-doc (<<
    3000.2.1-5), now that these are all shipped with ghc (closes: #800423).

 -- Colin Watson <cjwatson@debian.org>  Tue, 05 Jan 2016 10:22:34 +0000

ghc (7.10.3-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add debian/patches/armel-revert-ghci-fixes.patch which reverts
    the ARM ghci fixes, but apply the patch on armel only with
    the help of the debian/rules file (Closes: #807020).

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sun, 20 Dec 2015 17:01:39 +0100

ghc (7.10.3-4) unstable; urgency=medium

  [ Colin Watson ]
  * Disable PIE on s390x, since Ubuntu's toolchain defaults to enabling it
    there (closes: #807366).

  [ Joachim Breitner ]
  * Add patch for Sparc64. Again thanks to John Paul Adrian Glaubitz for the
    patch (Closes: #807777).

 -- Joachim Breitner <nomeata@debian.org>  Mon, 14 Dec 2015 09:09:52 +0100

ghc (7.10.3-3) unstable; urgency=medium

  * Platform detection support for sh4 (Closes: #807108). Thanks to John Paul
    Adrian Glaubitz for the patch.

 -- Joachim Breitner <nomeata@debian.org>  Sun, 06 Dec 2015 14:00:32 +0100

ghc (7.10.3-2) unstable; urgency=medium

  * Switch Vcs-Git/Vcs-Browser headers to new location.

 -- Clint Adams <clint@debian.org>  Thu, 03 Dec 2015 14:54:02 -0500

ghc (7.10.3-1) experimental; urgency=medium

  * New upstream version.

 -- Clint Adams <clint@debian.org>  Thu, 03 Dec 2015 10:38:40 -0500

ghc (7.10.2.20151030-3) experimental; urgency=medium

  * Apply a patch by Peter Trommler to fix
    "PPC.Ppr: Shift by 32 bits is not allowed." on powerpc

 -- Joachim Breitner <nomeata@debian.org>  Mon, 09 Nov 2015 18:58:11 +0100

ghc (7.10.2.20151030-2) experimental; urgency=medium

  * Patch Cabal to provide --show-detail=direct, mostly to work around
    problems with `setup test` on architectures with insufficient threading
    support in GHC: https://github.com/haskell/cabal/issues/2398

 -- Joachim Breitner <nomeata@debian.org>  Thu, 05 Nov 2015 12:38:32 +0100

ghc (7.10.2.20151030-1) experimental; urgency=medium

  * New upstream release (7.10.3-rc1)

 -- Joachim Breitner <nomeata@debian.org>  Mon, 02 Nov 2015 17:44:43 +0100

ghc (7.10.2-2) experimental; urgency=medium

  * Backport patch to fix GHC bug #10549, to unbreak shake’s test suite

 -- Joachim Breitner <nomeata@debian.org>  Sun, 16 Aug 2015 15:05:54 +0200

ghc (7.10.2-1) experimental; urgency=medium

  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Wed, 22 Jul 2015 11:17:24 +0200

ghc (7.10.1.20150630-2) experimental; urgency=medium

  * Remove PPC-relocations.patch

 -- Joachim Breitner <nomeata@debian.org>  Sat, 04 Jul 2015 10:06:16 +0200

ghc (7.10.1.20150630-1) experimental; urgency=medium

  [ Joachim Breitner ]
  * New upstream release candidate, 7.10.2-rc2
  * Clean up debian/control a bit, based on a patch by Gianfranco

  [ Gianfranco Costamagna ]
  * Bump std version
  * Refactor rules file to use dh

 -- Joachim Breitner <nomeata@debian.org>  Fri, 03 Jul 2015 12:28:07 +0200

ghc (7.10.1.20150612-1) experimental; urgency=medium

  * Calculate haddock interface version using the built haddock, not the
    installed (Thanks to David Fox for noticing).
  * New upstream release randidate (7.10.2-rc1)
  * Merge from unstable

 -- Joachim Breitner <nomeata@debian.org>  Mon, 15 Jun 2015 09:41:16 +0200

ghc (7.10.1-5) experimental; urgency=medium

  * Merge from unstable (Closes: #785282, #785194 )
  * A lucky guess at making GHC build reproducible, by not putting the process
    id in temporary filenames.

 -- Joachim Breitner <nomeata@debian.org>  Sun, 24 May 2015 10:47:09 +0200

ghc (7.10.1-4) experimental; urgency=medium

  * Fix patch/ghc-7.8.4-3-aarch64.patch; dropped a hunk when upgrading to
    7.10 that I should not have dropped. Thanks Gianfranco Costamagna for
    noticing.

 -- Joachim Breitner <nomeata@debian.org>  Thu, 14 May 2015 23:16:55 +0200

ghc (7.10.1-3) experimental; urgency=medium

  * Apply patch by Sergei Trofimovich to implement load_/store_load_barrier on
    armv6 and older (upstream ticket #10244)

 -- Joachim Breitner <nomeata@debian.org>  Thu, 14 May 2015 09:37:06 +0200

ghc (7.10.1-2) experimental; urgency=medium

  * Build against llvm-3.5 (Closes: 784245) 

 -- Joachim Breitner <nomeata@debian.org>  Wed, 13 May 2015 11:18:54 +0200

ghc (7.10.1-1) experimental; urgency=medium

  * New upstream release. Optimistically dropping lots of patches, lets see
    what now works out of the box.
  * Ship haddock with ghc, and leave (most) paths as they are. It is easier to
    not fight against the way upstream builds and installs stuff.
  * Remove the hack introduced in 7.2.0 for a clean upgrade from 7.0.3.

 -- Joachim Breitner <nomeata@debian.org>  Tue, 12 May 2015 12:41:40 +0200

ghc (7.8.4-9) unstable; urgency=medium

  * Another stab at making GHC more reproducible: Use a hash of the command
    line instead of the pid when calculating a "random" directory name.



=== debian/control ===
Source: ghc
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>, Clint Adams <clint@debian.org>
Standards-Version: 3.9.6
Build-Depends:
  debhelper (>= 9),
  devscripts,
  dh-autoreconf,
  autotools-dev,
  grep-dctrl,
  pkg-config,
  ghc (>= 7.8),
  libgmp-dev,
  llvm-3.5 (>= 1:3.5.1~) [arm64 armel armhf],
  libffi-dev,
  binutils [arm64 armel armhf],
  libncurses5-dev,
  xsltproc,
  docbook-xsl,
  docbook-xml,
  dpkg-dev (>= 1.16.1.1)
Build-Depends-Indep:
  hscolour,
  fop
Build-Conflicts:
  ccache
Homepage: http://haskell.org/ghc/
Vcs-Git: git://git.debian.org/git/pkg-haskell/DHG_packages.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/

Package: ghc
Architecture: any
Depends:
  llvm-3.5 (>= 1:3.5.1~) [arm64 armel armhf],
  gcc,
  libgmp-dev,
  libffi-dev,
  libbsd-dev,
  libc6-dev,
  libncurses5-dev,
  ${shlibs:Depends},
  ${misc:Depends}
Pre-Depends: dpkg (>= 1.16.1)
Provides:
  haskell-compiler,
  ghc-dynamic,
  ${ghci},
  ${provided-devs},
  ${haskell:Provides},
  haddock,
  ghc-haddock,
  ${haddock:Provides}
Replaces: ghc6 (<< 7), ghc-dynamic (<< 7.8), ghc-haddock (<< 7.10)
Conflicts: ghc6 (<< 7), ghc-dynamic (<< 7.8), ${conflicting-devs}
Breaks: cabal-install (<< 1.22), haskell-devscripts (<< 0.8.13), ghc-doc (<< 7.10), ghc-haddock (<< 7.10)
Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-3.5
Description: The Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.

Package: ghc-prof
Architecture: any
Provides: ${provided-profs}, ${haskell:Provides}
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Replaces: ghc6-prof (<< 7)
Conflicts: ghc6-prof (<< 7)
Description: Profiling libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc-doc
Section: doc
Architecture: all
Suggests: haskell-doc
Provides: ${provided-docs}
Replaces: ghc6-doc (<< 7), libghc-terminfo-doc (<< 0.3.2.5-4), libghc-transformers-doc (<< 0.3.0.0-6), libghc-xhtml-doc (<< 3000.2.1-5)
Conflicts: ghc6-doc (<< 7), ghc (<= 7.0.3-1)
Breaks: libghc-terminfo-doc (<< 0.3.2.5-4), libghc-transformers-doc (<< 0.3.0.0-6), libghc-xhtml-doc (<< 3000.2.1-5)
Depends: ${haddock:Depends}, ${misc:Depends}, perl
Pre-Depends: dpkg (>= 1.16.1)
Description: Documentation for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# # Set default flags with dpkg-buildflags
# # This might also close #712228
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
# ghc-cabal expects it to be available.
export HOME = /homedoesnotexistatbuildtime

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
# Commented out for now.  The build scripts don't recognise i486 as an
# architecture and cross compiling isn't supported anyway.
#ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
#  confflags += --build $(DEB_HOST_GNU_TYPE)
#else
#  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
#endif

ProjectVersion=$(shell cat VERSION)

GHC=$(firstword $(shell bash -c "type -p ghc"))
EXTRA_CONFIGURE_FLAGS=--with-ghc="$(GHC)"
ifeq (s390x,$(DEB_HOST_ARCH))
  EXTRA_CONFIGURE_FLAGS += \
	CONF_CC_OPTS_STAGE2=-fno-PIE \
	CONF_GCC_LINKER_OPTS_STAGE2=-no-pie \
	CONF_LD_LINKER_OPTS_STAGE2=-no-pie
endif
BUILD_HADDOCK_DOCS=YES
DEB_HOOGLE_TXT_DIR = /usr/lib/ghc-doc/hoogle/

%:
	dh $@ --with autotools-dev

override_dh_auto_configure:
	dh_autoreconf perl -- boot
	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
	echo "HADDOCK_DOCS := YES" >> mk/build.mk
	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
ifneq (,$(findstring $(DEB_HOST_ARCH), arm64 armel armhf))
	echo "SRC_HC_OPTS     += -optl-B/usr/bin/ld.gold" >> mk/build.mk
endif
ifeq (armhf,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -D__ARM_PCS_VFP" >> mk/build.mk
endif
ifeq (armel,$(DEB_HOST_ARCH))
	patch -p1 < debian/patches/armel-revert-ghci-fixes.patch
endif
ifeq (s390x,$(DEB_HOST_ARCH))
	echo "SRC_CC_OPTS += -fno-PIE" >> mk/build.mk
	echo "SRC_LD_OPTS += -no-pie" >> mk/build.mk
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
#	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
#	echo "GhcStage2HcOpts += -DDEBUG" >> mk/build.mk
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -Rghc-timing -DDEBUG" >> mk/build.mk
#	echo "GhcLibHcOpts  += -O -dcore-lint -keep-hc-files " >> mk/build.mk
	echo "SplitObjs     = NO" >> mk/build.mk
	echo "STRIP         = :" >> mk/build.mk
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -O0" >> mk/build.mk
	# This breaks the build - to be investigated:
	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
endif
	# We also want to build the threaded profiling-enabled debug runtime,
	# because it does no harm
	echo 'GhcRTSWays += $$(if $$(findstring p, $$(GhcLibWays)),thr_debug_p,)' >> mk/build.mk
	
	# We can't do this with a configure flag in 6.8.1 as libdir is not
	# defined at the point at which we := it
	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
	echo 'bindir  := /usr/bin' >> mk/build.mk
	# docdir doesn't have a configure flag, and unfortunately
	# we also need to explicitly define all of its dependents as they
	# are set with :=
	echo 'docdir  := $$(datarootdir)/doc/ghc-doc' >> mk/build.mk
	echo 'htmldir := $$(docdir)'                   >> mk/build.mk
	echo 'dvidir  := $$(docdir)'                   >> mk/build.mk
	echo 'pdfdir  := $$(docdir)'                   >> mk/build.mk
	echo 'psdir   := $$(docdir)'                   >> mk/build.mk
	# We want verbose builds
	echo 'V=1'                                     >> mk/build.mk
	./configure $(confflags) --prefix=/usr \
		$(EXTRA_CONFIGURE_FLAGS) \
		--with-system-libffi \
		--with-llc=llc-3.5 \
		--with-opt=opt-3.5

override_dh_auto_build:
	dh_auto_build
	# Do some very simple tests that the compiler actually works
	rm -rf debian/testghc
	mkdir debian/testghc
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*

FILES = \( -type f -o -type l \)
PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)

override_dh_auto_install:
	dh_auto_install

	# Delete all the library LICENSE files
	rm -f debian/tmp/usr/share/doc/ghc-doc/html/libraries/*/LICENSE

	# Remove the haddock.t files, they really should not be in the released
	# package (upstream #10410)
	find debian/tmp -name \*.haddock.t -delete

	# Generate lintian overrides
	mkdir -p debian/tmp/usr/share/lintian/overrides
	echo "ghc binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc-prof

	# Sort out the package.conf files
	mkdir -p debian/tmp/var/lib/ghc
	# Old directories for symlink-workaround. Remove once all libraries use new path
	mv debian/tmp/usr/lib/ghc/package.conf.d \
	   debian/tmp/var/lib/ghc/
	rm debian/tmp/var/lib/ghc/package.conf.d/package.cache
	chmod +x debian/provided_substvars
	debian/provided_substvars
	sed -ri 's,^haddock-interfaces: /.*?/libraries/,haddock-interfaces: /usr/lib/ghc-doc/haddock/ghc/,' debian/tmp/var/lib/ghc/package.conf.d/*.conf

	# Sort out the binaries
	if inplace/bin/ghc-stage2 --info | grep '"Have interpreter","NO"'; then \
	    cd debian/tmp/usr/bin ;rm -f ghci* runghc* runhaskell*; \
	fi

	# Check if we have a ghci binary
	if test -e debian/tmp/usr/bin/ghci-$(ProjectVersion); then \
	    echo 'ghci=ghc-ghci' >> debian/ghc.substvars ; fi

	# Add haddock substvars
	echo "haddock:Depends=haddock-interface-$$(debian/tmp/usr/lib/ghc/bin/haddock --interface-version)" >> debian/ghc-doc.substvars
	echo "haddock:Provides=haddock-interface-$$(debian/tmp/usr/lib/ghc/bin/haddock --interface-version)" >> debian/ghc.substvars

ifeq (YES,$(BUILD_HADDOCK_DOCS))
	mkdir -p debian/tmp/usr/lib/ghc-doc
	cp debian/gen_contents_index debian/tmp/usr/lib/ghc-doc/
	chmod +x debian/tmp/usr/lib/ghc-doc/gen_contents_index
	mkdir debian/tmp/usr/lib/ghc-doc/haddock
	mkdir debian/tmp/usr/lib/ghc-doc/haddock/ghc/
	for f in `find debian/tmp/usr/share/doc/ghc-doc/html/libraries/ -maxdepth 1 -mindepth 1 -type d`; do \
	    mkdir debian/tmp/usr/lib/ghc-doc/haddock/ghc/`basename $$f` ; \
	    mv $$f/*.haddock debian/tmp/usr/lib/ghc-doc/haddock/ghc/`basename $$f` ; done
	cd debian/tmp/usr/share/doc/ghc-doc/html/libraries/; ln -s ghc-$(ProjectVersion) ghc
	install -Dm 644 debian/index.html debian/tmp/usr/share/doc/ghc-doc/index.html
endif

	# manpages
	rm -f debian/*.1
	echo ".so man1/ghc.1" > debian/ghc-$(ProjectVersion).1
	if test -e debian/tmp/usr/bin/ghci-$(ProjectVersion); then \
	    echo ".so man1/ghc.1" > debian/ghci.1 ;\
	    echo ".so man1/ghc.1" > debian/ghci-$(ProjectVersion).1 ;\
	    cp debian/runghc.man debian/runghc.1 ; fi
	mv debian/tmp/usr/share/man/man1/ghc.1 debian/ghc.1
	cp utils/hp2ps/hp2ps.1 debian/hp2ps.1
	cp debian/ghc-pkg.man debian/ghc-pkg.1
	echo ".so man1/ghc-pkg.1" > debian/ghc-pkg-$(ProjectVersion).1

	echo debian/*.1 > debian/ghc.manpages
	cp debian/haddock.man debian/haddock.1

=== debian/watch ===
version=3
http://downloads.haskell.org/~ghc/(\d[\d.]*)/ghc-(\d[\d.]*)-src.tar.bz2

## ghc 8.0.1

=== libraries/Cabal/Cabal/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-VERSION=1.22.5.0
+VERSION=1.24.0.0
 
 #KIND=devel
 KIND=rc
@@ -14,7 +14,10 @@
 
 # build the library itself
 
-SOURCES=Distribution/*.hs Distribution/Simple/*.hs Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs Distribution/Simple/Build/*.hs Distribution/Compat/*.hs Distribution/Simple/Program/*.hs
+SOURCES=Distribution/*.hs Distribution/Simple/*.hs \
+	Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs \
+	Distribution/Simple/Build/*.hs Distribution/Compat/*.hs \
+	Distribution/Simple/Program/*.hs
 CONFIG_STAMP=dist/setup-config
 BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
 HADDOCK_STAMP=dist/doc/html/Cabal/index.html
@@ -23,13 +26,12 @@
 DISTLOC=dist/release
 DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz
 
-TMP := $(shell mktemp -d)
-
 COMMA=,
 
 setup: $(SOURCES) Setup.hs
 	-mkdir -p dist/setup
-	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs -o setup
+	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs \
+		-o setup
 
 $(CONFIG_STAMP): setup Cabal.cabal
 	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)
@@ -60,7 +62,9 @@
 	mkdir -p $(PANDOC_HTML_OUTDIR)
 	for file in $^; do \
 		[ $${file} != doc/index.markdown ] && TOC=--table-of-contents || TOC=; \
-		$(PANDOC) $(PANDOC_OPTIONS) $${TOC} --from=markdown --to=html --output $(PANDOC_HTML_OUTDIR)/$$(basename $${file} .markdown).html $${file}; \
+		$(PANDOC) $(PANDOC_OPTIONS) $${TOC} --from=markdown --to=html \
+			--output $(PANDOC_HTML_OUTDIR)/$$(basename $${file} .markdown).html \
+			$${file}; \
 	done
 	cp doc/$(PANDOC_HTML_CSS) $(PANDOC_HTML_OUTDIR)
 
@@ -113,15 +117,6 @@
 	scp -r $(DISTLOC) $(SSH_USER)@haskell.org:/home/web/haskell.org/cabal/release/cabal-$(VERSION)
 	ssh $(SSH_USER)@haskell.org 'cd /home/web/haskell.org/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'
 
-release-new: $(DIST_STAMP)
-	@echo "cd cabal/release" > $(TMP)/cabal-sftp-$(VERSION)
-	@echo "-mkdir cabal-$(VERSION)" >> $(TMP)/cabal-sftp-$(VERSION)
-	@echo "cd cabal-$(VERSION)" >> $(TMP)/cabal-sftp-$(VERSION)
-	@echo "lcd $(DISTLOC)" >> $(TMP)/cabal-sftp-$(VERSION)
-	@echo "put -r . ." >> $(TMP)/cabal-sftp-$(VERSION)
-	sftp -b $(TMP)/cabal-sftp-$(VERSION) $(SSH_USER)@wiki.haskell.org
-	@echo "You still need to manually update the 'latest' links"
-
 # tags...
 
 TAGSSRCDIRS = Distribution Language

=== libraries/containers/tests/Makefile ===
# The tests should be compiled and run using cabal:
# > cabal configure --enable-tests
# > cabal build
# > cabal test
#
# This Makefile is used by developers to compile the tests manually.

all:

%-properties: %-properties.hs force
	ghc -O2 -DTESTING $< -i.. -o $@ -outputdir tmp

%-strict-properties: %-properties.hs force
	ghc -O2 -DTESTING -DSTRICT $< -o $@ -i.. -outputdir tmp

.PHONY: force clean
force:

clean:
	rm -rf tmp $(patsubst %.hs, %, $(wildcard *-properties.hs)) $(patsubst %-properties.hs, %-strict-properties, $(wildcard *-properties.hs))

=== debian/changelog ===
ghc (8.0.1-17) unstable; urgency=medium

  * Add upstream patch "Add relocation type R_X86_64_REX_GOTPCRELX".

 -- Clint Adams <clint@debian.org>  Fri, 16 Dec 2016 21:44:45 -0500

ghc (8.0.1-16) unstable; urgency=medium

  * Patch to fix SMP support enablement on armhf.

 -- Clint Adams <clint@debian.org>  Wed, 14 Dec 2016 23:10:26 -0500

ghc (8.0.1-15) unstable; urgency=high

  * Add osdecommitmemory-compat.patch (Closes: #847677).

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 10 Dec 2016 15:03:42 -0700

ghc (8.0.1-14) unstable; urgency=medium

  * Upload to unstable.

 -- Clint Adams <clint@debian.org>  Mon, 14 Nov 2016 11:35:40 -0500

ghc (8.0.1-13) experimental; urgency=medium

  * Include ghc --info output in build log.
  * PPC/CodeGen: fix lwa instruction generation.   closes: #844323

 -- Clint Adams <clint@debian.org>  Mon, 14 Nov 2016 11:10:09 -0500

ghc (8.0.1-12) experimental; urgency=medium

  * Use upstream patch for '-no-pie'.
    Drop our custom 'opt-pic' and 'no-pie' patches and use one provided by
    the upstream developers.

 -- Ilias Tsitsimpis <i.tsitsimpis@gmail.com>  Fri, 11 Nov 2016 17:45:03 +0200

ghc (8.0.1-11) unstable; urgency=medium

  * Team upload.

  [ John Paul Adrian Glaubitz ]
  * Add patch x32-use-native-x86_64-insn.patch to support
    x32 architecture (Closes: #814657)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 06 Nov 2016 23:31:09 +0100

ghc (8.0.1-10) unstable; urgency=medium

  [ Emilio Pozuelo Monfort ]
  * Re-enable parallel builds, broken since 7.10.1.20150630-1.

  [ Clint Adams ]
  * Upstream patch c30b179a73d9fd3f6edcdda5e881523cd6edd46a to Cabal,
    fixing incorrect retrieval of ld flags.

 -- Clint Adams <clint@debian.org>  Sun, 06 Nov 2016 15:32:00 -0500

ghc (8.0.1-9) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Add upstream patch to avoid find_tycon panic (Closes: #842679).

  [ Clint Adams ]
  * Patch from James Clarke to prevent unaligned accesses on sparc64.
    closes: #842780.
  * Reduce memory usage when building on mips/mipsel.

 -- Clint Adams <clint@debian.org>  Tue, 01 Nov 2016 11:18:03 -0400

ghc (8.0.1-8) unstable; urgency=medium

  * Upload to unstable to start GHC 8 transition.

 -- Clint Adams <clint@debian.org>  Thu, 27 Oct 2016 18:32:16 -0400

ghc (8.0.1-7) experimental; urgency=medium

  * Disable PIC on powerpc.

 -- Clint Adams <clint@debian.org>  Tue, 25 Oct 2016 23:56:41 -0400

ghc (8.0.1-6) experimental; urgency=medium

  * Patch GHC to pass `-no-pie' along with `-Wl,-r'.
  * Do not disable PIE during package configuration in d/rules.
    The above patch seems sufficient.

 -- Ilias Tsitsimpis <i.tsitsimpis@gmail.com>  Mon, 24 Oct 2016 19:48:26 +0300

ghc (8.0.1-5) experimental; urgency=medium

  * Switch PIC default to on for all architectures.

 -- Clint Adams <clint@debian.org>  Sat, 22 Oct 2016 18:20:02 -0400

ghc (8.0.1-4) experimental; urgency=medium

  [ Balint Reczey ]
  * Disable PIE to fix build when PIE is the default in gcc
    (change taken/revised from Ubuntu, Closes: #712228)

 -- Sven Bartscher <kritzefitz@debian.org>  Thu, 13 Oct 2016 18:49:00 +0200

ghc (8.0.1-3) experimental; urgency=low

  * Removed the empty ghc-dbgsym package.

 -- Sven Bartscher <kritzefitz@debian.org>  Tue, 11 Oct 2016 16:43:21 +0200

ghc (8.0.1-2) experimental; urgency=medium

  [ Joachim Breitner ]
  * Merge from unstable (up to 7.0.3-9)

  [ Matthias Klose ]
  * Disable PIE on amd64 and ppc64el.

  [ Gianfranco Costamagna ]
  * Fix VCS fields

  [ Sven Bartscher ]
  * Depend on haskell-devscripts-minimal instead of duplicating its
    functionality.

 -- Sven Bartscher <kritzefitz@debian.org>  Fri, 05 Aug 2016 16:51:50 +0200

ghc (8.0.1-1) experimental; urgency=medium

  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Sat, 21 May 2016 17:03:18 +0200

ghc (8.0.0.20160421-1) experimental; urgency=medium

  * New upstream release candidate (8.0.1-rc4)

 -- Joachim Breitner <nomeata@debian.org>  Sat, 23 Apr 2016 17:56:45 +0200

ghc (8.0.0.20160411-1) experimental; urgency=medium

  * New upstream release candidate (8.0.1-rc3)

 -- Joachim Breitner <nomeata@debian.org>  Tue, 19 Apr 2016 09:11:57 +0200

ghc (8.0.0.20160204-2) experimental; urgency=medium

  * Build-Conflict: Do not bootstrap with ghc-8.0.1-rc1, as this is broken.

 -- Joachim Breitner <nomeata@debian.org>  Tue, 09 Feb 2016 10:05:24 +0100

ghc (8.0.0.20160204-1) experimental; urgency=medium

  [ Gianfranco Costamagna ]
  * Re-enable and refresh patches/armel-revert-ghci-fixes.patch on armel.
    - drop a little part on Linker.c, upstreamed.

  [ Joachim Breitner ]
  * New upstream release candidate (8.0.1-rc2)

 -- Joachim Breitner <nomeata@debian.org>  Mon, 08 Feb 2016 12:34:51 +0100

ghc (8.0.0.20160111-3) experimental; urgency=medium

  * Ah, there is llvm-3.7 in Debian. Must have been confused by the LLVM
    packaging... let’s use that.

 -- Joachim Breitner <nomeata@debian.org>  Mon, 18 Jan 2016 09:29:29 +0100

ghc (8.0.0.20160111-2) experimental; urgency=medium

  * Try to see if it builds without
    patches/armel-revert-ghci-fixes.patch on armel.
  * Try to build with LLVM 3.8 (upstream wants 3.7, but that is not in Debian
    any more)

 -- Joachim Breitner <nomeata@debian.org>  Mon, 18 Jan 2016 09:17:25 +0100

ghc (8.0.0.20160111-1) experimental; urgency=medium

  * New upstream release candiate (8.0.1-rc1)
    Dropped patches
    + cabal-show-detail-direct
    + sh4-platform-detection-support
    + parc64-initial-platform-support
  * Configure haddock to use locally provided mathjax files, and let ghc-doc
    depend on libjs-mathjax.
  * Backport upstream patch D1782 to unbreak manpage building
  * Add gpg key ot debian/upstream and use it in debian/watch

 -- Joachim Breitner <nomeata@debian.org>  Thu, 14 Jan 2016 16:16:37 +0100

ghc (7.10.3-10) unstable; urgency=medium

  [ Clint Adams ]
  * Backport upstream 563a4857abcee4a6e43c68323274309c58f42aa0 to use gcc's


=== debian/rules ===
--- 
+++ 
@@ -34,22 +34,22 @@
 
 GHC=$(firstword $(shell bash -c "type -p ghc"))
 EXTRA_CONFIGURE_FLAGS=--with-ghc="$(GHC)"
-ifeq (s390x,$(DEB_HOST_ARCH))
-  EXTRA_CONFIGURE_FLAGS += \
-	CONF_CC_OPTS_STAGE2=-fno-PIE \
-	CONF_GCC_LINKER_OPTS_STAGE2=-no-pie \
-	CONF_LD_LINKER_OPTS_STAGE2=-no-pie
-endif
+
 BUILD_HADDOCK_DOCS=YES
 DEB_HOOGLE_TXT_DIR = /usr/lib/ghc-doc/hoogle/
 
+ifeq (x32,$(DEB_HOST_ARCH))
+  EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
+endif
+
 %:
-	dh $@ --with autotools-dev
+	dh $@ --parallel --with autotools-dev
 
 override_dh_auto_configure:
 	dh_autoreconf perl -- boot
 	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
 	echo "HADDOCK_DOCS := YES" >> mk/build.mk
+	echo "EXTRA_HADDOCK_OPTS += --mathjax=file:///usr/share/javascript/mathjax/MathJax.js" >> mk/build.mk
 	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
 ifneq (,$(findstring $(DEB_HOST_ARCH), arm64 armel armhf))
 	echo "SRC_HC_OPTS     += -optl-B/usr/bin/ld.gold" >> mk/build.mk
@@ -60,9 +60,11 @@
 ifeq (armel,$(DEB_HOST_ARCH))
 	patch -p1 < debian/patches/armel-revert-ghci-fixes.patch
 endif
-ifeq (s390x,$(DEB_HOST_ARCH))
-	echo "SRC_CC_OPTS += -fno-PIE" >> mk/build.mk
-	echo "SRC_LD_OPTS += -no-pie" >> mk/build.mk
+ifneq (,$(findstring $(DEB_HOST_ARCH), mips mipsel))
+	echo "SRC_HC_OPTS     += -optc--param -optcggc-min-expand=10" >> mk/build.mk
+endif
+ifeq (x32,$(DEB_HOST_ARCH))
+	echo "INTEGER_LIBRARY = integer-simple" >> mk/build.mk
 endif
 ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
 #	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
@@ -83,7 +85,7 @@
 	# We also want to build the threaded profiling-enabled debug runtime,
 	# because it does no harm
 	echo 'GhcRTSWays += $$(if $$(findstring p, $$(GhcLibWays)),thr_debug_p,)' >> mk/build.mk
-	
+
 	# We can't do this with a configure flag in 6.8.1 as libdir is not
 	# defined at the point at which we := it
 	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
@@ -101,8 +103,8 @@
 	./configure $(confflags) --prefix=/usr \
 		$(EXTRA_CONFIGURE_FLAGS) \
 		--with-system-libffi \
-		--with-llc=llc-3.5 \
-		--with-opt=opt-3.5
+		--with-llc=llc-3.7 \
+		--with-opt=opt-3.7
 
 override_dh_auto_build:
 	dh_auto_build
@@ -117,6 +119,9 @@
 	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
 	[ "$$(debian/testghc/foo)" = "Foo" ]
 	rm debian/testghc/*
+	@printf "====BEGIN GHC INFO OUTPUT====\n"
+	@inplace/bin/ghc-stage2 --info
+	@printf "====END GHC INFO OUTPUT====\n"
 
 FILES = \( -type f -o -type l \)
 PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)
@@ -181,9 +186,3 @@
 	    echo ".so man1/ghc.1" > debian/ghci-$(ProjectVersion).1 ;\
 	    cp debian/runghc.man debian/runghc.1 ; fi
 	mv debian/tmp/usr/share/man/man1/ghc.1 debian/ghc.1
-	cp utils/hp2ps/hp2ps.1 debian/hp2ps.1
-	cp debian/ghc-pkg.man debian/ghc-pkg.1
-	echo ".so man1/ghc-pkg.1" > debian/ghc-pkg-$(ProjectVersion).1
-
-	echo debian/*.1 > debian/ghc.manpages
-	cp debian/haddock.man debian/haddock.1

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/ \
http://downloads.haskell.org/~ghc/(\d[\d.rc-]*)/ghc-(\d[\d.]*)-src.tar.(?:bz2|xz|gz)
